#version 410 core

in vec2 uv;
in vec3 frag_normal;
in vec3 frag_pos;

uniform sampler2D diffuse_sampler;
uniform vec3 camera_pos;
uniform vec3 light_pos;

out vec4 color;

void main(void) {
    vec3 light_vec = normalize(light_pos - frag_pos);
    vec3 view_vec = normalize(camera_pos - frag_pos);
    float diff_coeff = max(dot(light_vec, normalize(frag_normal)), 0);
    vec3 half_vec = normalize(light_vec + view_vec);
    color = vec4(
        texture(diffuse_sampler, uv).rgb * diff_coeff +
		vec3(0.01, 0.01, 0.01) + 
        pow(max(dot(half_vec, normalize(frag_normal)), 0), 50)
        , 1.0);
}