#version 410 core

in vec3 frag_normal;
in vec3 frag_pos;

uniform vec3 camera_pos;
uniform vec3 light_pos;
uniform vec3 mesh_color;

out vec4 color;

void main() {
	float attenuation = pow(5/length(light_pos - frag_pos), 1);
    vec3 light_vec = normalize(light_pos - frag_pos);
    vec3 view_vec = normalize(camera_pos - frag_pos);
    float diff_coeff = max(dot(light_vec, normalize(frag_normal)), 0);
    vec3 half_vec = normalize(light_vec + view_vec);
    color = vec4(
        mesh_color.rgb * diff_coeff * attenuation +
		vec3(0.01, 0.01, 0.01) +
        pow(max(dot(half_vec, normalize(frag_normal)), 0), 20) * attenuation / 5
        , 1.0);
	color = vec4(1,1,1,1);
}
