#version 410 core

layout (location = 0) in vec3 vertex_pos;
layout (location = 1) in vec3 normal_pos;

uniform mat4 m_matrix;
uniform mat4 vp_matrix;

out vec3 frag_normal;
out vec3 frag_pos;

void main() {
	frag_pos = (m_matrix * vec4(vertex_pos, 1.0)).xyz;
    frag_normal = (m_matrix * vec4(normal_pos, 0.0)).xyz;
	gl_Position = vp_matrix * vec4(frag_pos, 1.0);
}
