#version 410 core

in vec2 uv;

uniform sampler2D scene;
uniform sampler2D blur;

out vec4 color;

void main(void) {
	const float exposure = 1.0f;
	
    vec3 hdr_color = texture(scene, uv).rgb;      
    vec3 blur_color = texture(blur, uv).rgb;
	
    hdr_color += blur_color;
	
    vec3 result = vec3(1.0f) - exp(-hdr_color * exposure);
	
    color = vec4(result, 1.0f);
}