#version 410 core

layout (location = 0) in vec3 vertex_pos;

uniform mat4 m_matrix;
uniform mat4 vp_matrix;
uniform vec3 camera_pos;

out vec3 uv;

void main(void) {
	vec4 frag_pos = m_matrix * vec4(vertex_pos, 1.0);
	
	gl_Position = vp_matrix * frag_pos;
	
	vec3 barycenter = vec3(m_matrix[3]);
	vec3 offset = camera_pos - barycenter;
	
	// blender rotation...
    uv = mat3(m_matrix) * vertex_pos - offset;
}