#version 410

layout (location = 0) in vec3 vertex_pos;

uniform vec2 screen_size;

out vec2 uv;
out vec2 uv_blurred[6];

void main() {
    gl_Position = vec4(vertex_pos, 1.0);
	uv = vertex_pos.xy / 2.0f + 0.5f;
	
	vec2 duv = vec2(1.f / (screen_size.x - 1.f), 0.f);
	
	uv_blurred[0] = uv - 3 * duv;
    uv_blurred[1] = uv - 2 * duv;
    uv_blurred[2] = uv - 1 * duv;
    uv_blurred[3] = uv + 1 * duv;
	uv_blurred[4] = uv + 2 * duv;
	uv_blurred[5] = uv + 3 * duv;
}
