#version 410 core

in vec2 uv;

uniform float exposure;
uniform float decay;
uniform float density;
uniform float weight;	
uniform sampler2D occlusion_sampler;
uniform vec3 light_pos_screen;

out vec4 color;

void main(void) {
	const float NUM_SAMPLES = 30;
	

	vec2 current_uv = uv;
	vec2 delta_uv = (current_uv - light_pos_screen.xy);  
	delta_uv *= 1.0f / NUM_SAMPLES * density; 
	float illumination_decay = 1.0f;  
	vec3 current_color = texture(occlusion_sampler, current_uv).rgb;
	
	for(int i = 0; i < NUM_SAMPLES; i++) {
		current_uv -= delta_uv;
		vec3 diffuse_sample = texture(occlusion_sampler, current_uv).rgb;	
		diffuse_sample *= illumination_decay * weight;
		current_color += diffuse_sample;
		illumination_decay *= decay;
	}
	
	color = vec4(current_color * exposure, 1);

}