#version 410 core

layout (location = 0) in vec3 vertex_pos;
layout (location = 1) in float decay_factor;
layout (location = 2) in float curr_frame;
layout (location = 3) in float size;
layout (location = 4) in float start_hue;
layout (location = 5) in float end_hue;

uniform mat4 v_matrix;

out float curr_frame_gs;
out float size_gs;
out float decay_factor_gs;
out float hue_gs;

void main() {
	gl_Position = v_matrix * vec4(vertex_pos, 1.0);
	curr_frame_gs = curr_frame;
	size_gs = size;	
	decay_factor_gs = decay_factor;
	hue_gs = start_hue * (1.0 - decay_factor) + end_hue * decay_factor;
}