#version 410 core

in vec3 frag_normal;
in vec3 frag_pos;

uniform samplerCube skybox_sampler;
uniform vec3 camera_pos;

out vec4 color;

void main(void) {
	// Air 1.00
	// Water 1.33
	// Ice 1.309
	// Glass 1.52
	// Diamond 2.42
	
	vec3 view_vec = normalize(frag_pos - camera_pos);
	vec3 refraction_vec = refract(view_vec, normalize(frag_normal), 1.00 / 1.52);

	color = texture(skybox_sampler, refraction_vec);
}